#include "AmiMirrorPrefs.h" // defines and other
#include "SomeOther.h"      // some other routines
#include "graphica.h"       // graphics data
#include "MainWin.h"        // Main window procedures
#include "XpkWin.h"         // XPK window procedures
#include "StartEnd.h"       // (Un)initialization

/*                           
        main()      
                                                     
               Good program must have only one function :)                 

*/

void main (void)
{
  if (Init())
    {
      if (AmiMirrorPrefs = ApplicationObject,
                           MUIA_Application_Title,       GETMES(PROG_NAME),
                           MUIA_Application_Base,        GETMES(PROG_NAME),
                           MUIA_Application_Version,     GETMES(PROG_VERSION),
                           MUIA_Application_Copyright,   GETMES(PROG_COPYRIGHT),
                           MUIA_Application_Author,      GETMES(PROG_AUTHOR),
                           MUIA_Application_Description, GETMES(PROG_DESC),
                           MUIA_Application_SingleTask,  TRUE,
                           SubWindow, MainWin = NewObject (mw_mcc->mcc_Class, NULL, TAG_DONE),
                           SubWindow, XpkWin  = NewObject (xw_mcc->mcc_Class, NULL, TAG_DONE),
           End)
        {
          struct Task *task;
          ULONG sigs = 0L;

          if (task = FindTask(NULL))
            task->tc_Node.ln_Name = TASK_PREFS_NAME;
          DoMethod (MainWin, MUIM_MW_Open, TRUE);

          while (DoMethod (AmiMirrorPrefs, MUIM_Application_NewInput, &sigs) != MUIV_Application_ReturnID_Quit)
            {
              if (sigs)
                {
                  sigs = Wait (sigs | SIGBREAKF_CTRL_C);
                  if (sigs & SIGBREAKF_CTRL_C)
                    break;
                }
            }
          set (XpkWin,  MUIA_Window_Open, FALSE);
          set (MainWin, MUIA_Window_Open, FALSE);
          MUI_DisposeObject (AmiMirrorPrefs);
        }
      else if (MainWin && XpkWin)
        MakeRequest (REQ_TITLE_ERROR, APPLICATION_PROBLEM, EXIT_BUT, NULL);
    }
  Free();
}
