/* $VER:  TTM-LoadIcon.rexx 1.1 (21.11.98) by J. Tierney

  TTManager Load Icon  v1.1
  11/21/98  J. Tierney <jtierney@cyberlink-inc.com>


  Purpose:  Open new TTManger windows.

  Usage:  TTM-LoadIcon.rexx [<filenames>] , [<pubscreen>]

          <filenames> - Name(s) of icon(s) to load.
                        Optional; a file requester will open if no names are given.

          <pubscreen> - Name of a public screen to open the windows on.
                        Optional; defaults to TTManager's current screen (set via
                        PUBSCREEN  or SetScreen).

  Examples:
    RX TTM-LoadIcon.rexx SYS:Utilities/MultiView

    RX TTM-LoadIcon.rexx , DM.1

    RX TTM-LoadIcon.rexx SYS:Utilities/MultiView T:Bla SYS:T, IBROWSE


  History:
    1.0 (11/27/97)
*/

ttm = 'TTManager NOWARNINGS' /* Change this line to the path & options you use
                                for TTM, in case it isn't already running. */

OPTIONS RESULTS

PARSE ARG line
PARSE VAR line files ',' pubscr

files = STRIP(files, 'B')
pubscr = STRIP(pubscr, 'B')

/* Start TTM if it isn't already running. */
IF ~SHOW('P', 'TTMANAGER') THEN DO
  ADDRESS COMMAND 'Run >NIL:' ttm
  ADDRESS COMMAND 'SYS:RexxC/WaitForPort TTMANAGER'
  IF rc ~= 0 THEN DO
    MSG 'Unable to find TTManager''s port.'
    EXIT 10
  END
END

ADDRESS 'TTMANAGER'

IF pubscr ~= '' THEN DO
  'GetScreen'
  oldscr = result
  'SetScreen' pubscr
  END
ELSE oldscr = ''

'NewWindow' files

IF oldscr ~= '' THEN 'SetScreen' oldscr

